/** fichier libsmtp.h **/
#ifndef H_LIBSMTP
#define H_LIBSMTP
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <stdbool.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <dirent.h>
#include <resolv.h>




/******************************************************************/
/** Ce fichier decrit les structures et les constantes utilisees **/
/** par les fonctions SMTP                   **/
/******************************************************************/

/**** Constantes ****/

/**** Fonctions ****/

struct Information
{
	int relay_or_not;
	int debut_message;
	char from [1024];
	char subject[1024];
	char to [1024];
	char mailServer[1024];
	FILE *fd_status;
	FILE *fd_message;
	FILE *fd_tampon;
	int fd_mailbox;
	char racine[100]; // chemin du fichier de stockage des messages (aprés concaténation)
	char racine2[100] ; // chemin du fichier .status (aprés concaténation)
};


void gestionClient(int s);

int multi_gestionClient(int s);

char *resolv_addr(char *domaine) ;

static FILE *connServDist(struct Information Infos, const char *port) ;

struct Information relayMail(struct Information Infos, char* filename, char* portNum) ;

struct Information commandeHELO(char *buffer, int s, struct Information Infos);

struct Information commandeMAIL(char *buffer, int s, struct Information Infos);

struct Information commandeRCPT(char *buffer, int s,struct Information Infos);

struct Information  commandeDATA(char *buffer,  int s, struct Information Infos);

struct Information commande_traiter_DATA;

struct Information commande_fin_DATA(char *buffer,  int s,struct Information Infos);

void commandeQUIT(char *buffer,  int s);

void commandeNOOP(char *buffer, int s);

void commandeRSET(char *buffer, int s);

struct Information redirection_Commandes(char *buffer, int s,struct Information Infos);

































#endif
